<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>The ESP-AT MQTT library project: src/AT.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">The ESP-AT MQTT library project
   </div>
   <div id="projectbrief">A simple wrapper to the MQTT functionality found in the ESP-AT interpreter</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#define-members">Macros</a> &#124;
<a href="#typedef-members">Typedefs</a> &#124;
<a href="#enum-members">Enumerations</a>  </div>
  <div class="headertitle">
<div class="title">AT.h File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &lt;inttypes.h&gt;</code><br />
<code>#include &lt;Arduino.h&gt;</code><br />
</div><div class="textblock"><div class="dynheader">
Include dependency graph for AT.h:</div>
<div class="dyncontent">
<div class="center"><img src="AT_8h__incl.png" border="0" usemap="#src_2AT_8h" alt=""/></div>
<map name="src_2AT_8h" id="src_2AT_8h">
<area shape="rect" title=" " alt="" coords="67,5,139,32"/>
<area shape="rect" title=" " alt="" coords="5,80,92,107"/>
<area shape="rect" title=" " alt="" coords="116,80,200,107"/>
</map>
</div>
</div><div class="textblock"><div class="dynheader">
This graph shows which files directly or indirectly include this file:</div>
<div class="dyncontent">
<div class="center"><img src="AT_8h__dep__incl.png" border="0" usemap="#src_2AT_8hdep" alt=""/></div>
<map name="src_2AT_8hdep" id="src_2AT_8hdep">
<area shape="rect" title=" " alt="" coords="36,5,108,32"/>
<area shape="rect" href="EspATMQTT_8h.html" title=" " alt="" coords="5,80,139,107"/>
</map>
</div>
</div>
<p><a href="AT_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAT__Class.html">AT_Class</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">EspAT MQTT <a class="el" href="classAT__Class.html" title="EspAT MQTT AT_Class definition.">AT_Class</a> definition.  <a href="classAT__Class.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:a3b74832b85bcb7fd060d88c1e5fdd9d4"><td class="memItemLeft" align="right" valign="top"><a id="a3b74832b85bcb7fd060d88c1e5fdd9d4"></a>
#define&#160;</td><td class="memItemRight" valign="bottom"><b>AT_ERROR</b>(x)&#160;&#160;&#160;(x &amp; 0x00ff0000)</td></tr>
<tr class="separator:a3b74832b85bcb7fd060d88c1e5fdd9d4"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="typedef-members"></a>
Typedefs</h2></td></tr>
<tr class="memitem:a0c488f966048be07ee0f11f6969c3524"><td class="memItemLeft" align="right" valign="top">typedef uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="AT_8h.html#a0c488f966048be07ee0f11f6969c3524">at_status_t</a></td></tr>
<tr class="memdesc:a0c488f966048be07ee0f11f6969c3524"><td class="mdescLeft">&#160;</td><td class="mdescRight">The return value of an AT operation.  <a href="AT_8h.html#a0c488f966048be07ee0f11f6969c3524">More...</a><br /></td></tr>
<tr class="separator:a0c488f966048be07ee0f11f6969c3524"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="enum-members"></a>
Enumerations</h2></td></tr>
<tr class="memitem:a796b7f69ede31ae39a12a24208c20701"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701">status_code_e</a> { <br />
&#160;&#160;<a class="el" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701ab65c93b365084d675c9c8d2cb85c5aee">ESP_AT_SUB_OK</a> = 0x00000000, 
<a class="el" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701ad878aae06ef0af5bf7459d4e732d28e3">ESP_AT_SUB_COMMON_ERROR</a> = 0x01010000, 
<a class="el" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a8ece757353d9b9d754fe7ee3dffdf009">ESP_AT_SUB_NO_TERMINATOR</a> = 0x01020000, 
<a class="el" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701aac490b7434e97cd6dda5dc06829a4752">ESP_AT_SUB_NO_AT</a> = 0x01030000, 
<br />
&#160;&#160;<a class="el" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701ad6e0b28873f7e82345fb0892c275d623">ESP_AT_SUB_PARA_LENGTH_MISMATCH</a> = 0x01040000, 
<a class="el" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a9f262dfc988438706a55a29a1748ae43">ESP_AT_SUB_PARA_TYPE_MISMATCH</a> = 0x01050000, 
<a class="el" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701ac6b5b10f52ea2612d8628f1897142997">ESP_AT_SUB_PARA_NUM_MISMATCH</a> = 0x01060000, 
<a class="el" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a2172796f23c221f4cee294a77fff49ed">ESP_AT_SUB_PARA_INVALID</a> = 0x01070000, 
<br />
&#160;&#160;<a class="el" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701ad9f84cae5eb8ee91f43e7a94becf5477">ESP_AT_SUB_PARA_PARSE_FAIL</a> = 0x01080000, 
<a class="el" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701ab3cd1c1b8a2a49a2111c57a512ef64c1">ESP_AT_SUB_UNSUPPORT_CMD</a> = 0x01090000, 
<a class="el" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701aa30973841455529fae37712f3aa654a0">ESP_AT_SUB_CMD_EXEC_FAIL</a> = 0x010a0000, 
<a class="el" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a829f94a8131058d90776ede8fa667dd2">ESP_AT_SUB_CMD_PROCESSING</a> = 0x010b0000, 
<br />
&#160;&#160;<a class="el" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a7ce30c99b5146f6e284e805b9beb4a6f">ESP_AT_SUB_CMD_OP_ERROR</a> = 0x010c0000, 
<a class="el" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a237643f44341c133761b13963b206fd2">ESP_AT_SUB_CMD_ERROR</a> = 0x010d0000, 
<a class="el" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a655b31e3aea3a2dd38449cc2f2290afd">ESP_AT_SUB_CMD_TIMEOUT</a> = 0x010e0000, 
<a class="el" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a5256452d9f75d0e7cea6ee0165dde42c">ESP_AT_SUB_CMD_CONN_SYNCH</a> = 0x010f0000, 
<br />
&#160;&#160;<a class="el" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701a3a4aba89e732f3573f346bb05fee636b">ESP_AT_SUB_CMD_CONN_ASYNCH</a> = 0x01100000, 
<b>ESP_AT_SUB_CMD_LAST_COMMAND</b>
<br />
 }</td></tr>
<tr class="memdesc:a796b7f69ede31ae39a12a24208c20701"><td class="mdescLeft">&#160;</td><td class="mdescRight">Status codes that the AT handler can return.  <a href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701">More...</a><br /></td></tr>
<tr class="separator:a796b7f69ede31ae39a12a24208c20701"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Typedef Documentation</h2>
<a id="a0c488f966048be07ee0f11f6969c3524"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0c488f966048be07ee0f11f6969c3524">&#9670;&nbsp;</a></span>at_status_t</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef uint32_t <a class="el" href="AT_8h.html#a0c488f966048be07ee0f11f6969c3524">at_status_t</a></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>The return value of an AT operation. </p>
<p>This value is represented by a member of the enum <a class="el" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701" title="Status codes that the AT handler can return.">status_code_e</a>. The caller can use the AT_ERROR macro to check for a specifik status code. </p>

</div>
</div>
<h2 class="groupheader">Enumeration Type Documentation</h2>
<a id="a796b7f69ede31ae39a12a24208c20701"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a796b7f69ede31ae39a12a24208c20701">&#9670;&nbsp;</a></span>status_code_e</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="AT_8h.html#a796b7f69ede31ae39a12a24208c20701">status_code_e</a></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Status codes that the AT handler can return. </p>
<p>These are basically the same return (error) codes that the ESP-AT module returns when an error is detected but we have added a few to simplify upper layer handling. </p>
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="a796b7f69ede31ae39a12a24208c20701ab65c93b365084d675c9c8d2cb85c5aee"></a>ESP_AT_SUB_OK&#160;</td><td class="fielddoc"><p>All is good in life and no errors have been detected. </p>
</td></tr>
<tr><td class="fieldname"><a id="a796b7f69ede31ae39a12a24208c20701ad878aae06ef0af5bf7459d4e732d28e3"></a>ESP_AT_SUB_COMMON_ERROR&#160;</td><td class="fielddoc"><p>A generic error has occured, no more info is available. </p>
</td></tr>
<tr><td class="fieldname"><a id="a796b7f69ede31ae39a12a24208c20701a8ece757353d9b9d754fe7ee3dffdf009"></a>ESP_AT_SUB_NO_TERMINATOR&#160;</td><td class="fielddoc"><p>The At interpretor did not detect a terminator. </p>
</td></tr>
<tr><td class="fieldname"><a id="a796b7f69ede31ae39a12a24208c20701aac490b7434e97cd6dda5dc06829a4752"></a>ESP_AT_SUB_NO_AT&#160;</td><td class="fielddoc"><p>Command was not prepended with "AT". </p>
</td></tr>
<tr><td class="fieldname"><a id="a796b7f69ede31ae39a12a24208c20701ad6e0b28873f7e82345fb0892c275d623"></a>ESP_AT_SUB_PARA_LENGTH_MISMATCH&#160;</td><td class="fielddoc"><p>Mismatch in the parameter length. </p>
</td></tr>
<tr><td class="fieldname"><a id="a796b7f69ede31ae39a12a24208c20701a9f262dfc988438706a55a29a1748ae43"></a>ESP_AT_SUB_PARA_TYPE_MISMATCH&#160;</td><td class="fielddoc"><p>Wrong parameter type. </p>
</td></tr>
<tr><td class="fieldname"><a id="a796b7f69ede31ae39a12a24208c20701ac6b5b10f52ea2612d8628f1897142997"></a>ESP_AT_SUB_PARA_NUM_MISMATCH&#160;</td><td class="fielddoc"><p>Incorrect number of parameters. </p>
</td></tr>
<tr><td class="fieldname"><a id="a796b7f69ede31ae39a12a24208c20701a2172796f23c221f4cee294a77fff49ed"></a>ESP_AT_SUB_PARA_INVALID&#160;</td><td class="fielddoc"><p>Invalid parameter value. </p>
</td></tr>
<tr><td class="fieldname"><a id="a796b7f69ede31ae39a12a24208c20701ad9f84cae5eb8ee91f43e7a94becf5477"></a>ESP_AT_SUB_PARA_PARSE_FAIL&#160;</td><td class="fielddoc"><p>Failed to parse parameter. </p>
</td></tr>
<tr><td class="fieldname"><a id="a796b7f69ede31ae39a12a24208c20701ab3cd1c1b8a2a49a2111c57a512ef64c1"></a>ESP_AT_SUB_UNSUPPORT_CMD&#160;</td><td class="fielddoc"><p>Found unsupported command. </p>
</td></tr>
<tr><td class="fieldname"><a id="a796b7f69ede31ae39a12a24208c20701aa30973841455529fae37712f3aa654a0"></a>ESP_AT_SUB_CMD_EXEC_FAIL&#160;</td><td class="fielddoc"><p>Command execution failed. </p>
</td></tr>
<tr><td class="fieldname"><a id="a796b7f69ede31ae39a12a24208c20701a829f94a8131058d90776ede8fa667dd2"></a>ESP_AT_SUB_CMD_PROCESSING&#160;</td><td class="fielddoc"><p>Error in command processing, this error always occur before a MQTT error happens. </p>
</td></tr>
<tr><td class="fieldname"><a id="a796b7f69ede31ae39a12a24208c20701a7ce30c99b5146f6e284e805b9beb4a6f"></a>ESP_AT_SUB_CMD_OP_ERROR&#160;</td><td class="fielddoc"><p>Error while performing and operation. </p>
</td></tr>
<tr><td class="fieldname"><a id="a796b7f69ede31ae39a12a24208c20701a237643f44341c133761b13963b206fd2"></a>ESP_AT_SUB_CMD_ERROR&#160;</td><td class="fielddoc"><p>Generic command error. </p>
</td></tr>
<tr><td class="fieldname"><a id="a796b7f69ede31ae39a12a24208c20701a655b31e3aea3a2dd38449cc2f2290afd"></a>ESP_AT_SUB_CMD_TIMEOUT&#160;</td><td class="fielddoc"><p><a class="el" href="classAT__Class.html" title="EspAT MQTT AT_Class definition.">AT_Class</a> timout waiting for a reply from the interpreter. </p>
</td></tr>
<tr><td class="fieldname"><a id="a796b7f69ede31ae39a12a24208c20701a5256452d9f75d0e7cea6ee0165dde42c"></a>ESP_AT_SUB_CMD_CONN_SYNCH&#160;</td><td class="fielddoc"><p>MQTT connection was synchronous. </p>
</td></tr>
<tr><td class="fieldname"><a id="a796b7f69ede31ae39a12a24208c20701a3a4aba89e732f3573f346bb05fee636b"></a>ESP_AT_SUB_CMD_CONN_ASYNCH&#160;</td><td class="fielddoc"><p>MQTT connection was asynchronous, a callback will be issued when the connection is made. </p>
</td></tr>
</table>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
